# Jupyter-OpenBIS-Authenticator

## Description

This authenticator module for JupyterHub connects to a given openBIS instance, using the pyBIS module. It exports the environment variables
* OPENBIS_URL
* OPENBIS_TOKEN

to the user environment. Later, in a notebook, a user is then able to use pyBIS without any url, username or credentials:

```
from pybis import Openbis
o = Openbis()
```

## Compatibility

This Authenticator works only with Jupyterhub > 0.8.0. This module was tested with version 0.8.1

The authenticator uses the `spawner.environment` feature to modify the users environment variables during session creation. This feature was introduced in Jupyterhub by version 0.8.0.

## Installation

```
pip install jupyter_openbis_authenticator
```

## Jupyterhub Configuration

Edit your `jupyterhub_config.py` file and add the following to register `jupyter_openbis_authenticator` as a JupyterHub authenticator class:

```
c.JupyterHub.authenticator_class = 'jupyter_openbis_authenticator.auth.OpenbisAuthenticator'

# enable persisting auth_state, i.e. enable JupyterHub to change the environment variables of the user.
c.Authenticator.enable_auth_state = True

# openBIS settings
c.OpenbisAuthenticator.server_url = 'https://my_openbis_instance.ch'
c.OpenbisAuthenticator.verify_certificates = True
```
